clear all
set more off
set maxvar 10000
set mem 500m
cap log close
pause on

cd "C:\Documents and Settings\qeh\My Documents\Teachings\Summer School OPHI - Delft2011\Exercise1"

use "2. OPHI-HDCA SS11 - Working Groups on Principal Components and Factor Analyses, data ss_haiti06, JMR.dta", clear

log using exercise1.log, replace


codebook radio television refrigerator bicycle motorbike car telephone electricity floor roof crowding d_wall1 d_wall2 d_wall3 d_toilet1 d_toilet2 d_toilet3 d_cookingfuel1 d_cookingfuel2 d_cookingfuel3 d_water1 d_water2 d_water3 d_water4 d_water5, tab(30)

factor radio television refrigerator bicycle motorbike car telephone electricity floor roof crowding d_wall1 d_wall2 d_wall3 d_toilet1 d_toilet2 d_toilet3 d_cookingfuel1 d_cookingfuel2 d_cookingfuel3 d_water1 d_water2 d_water3 d_water4 d_water5 [weight= weight], factor(1) pcf

predict factor_PCF


** We compare this results with other methods

* Command "pca" corresponds to principal component analysis

pca radio television refrigerator bicycle motorbike car telephone electricity floor roof crowding d_wall1 d_wall2 d_wall3 d_toilet1 d_toilet2 d_toilet3 d_cookingfuel1 d_cookingfuel2 d_cookingfuel3 d_water1 d_water2 d_water3 d_water4 d_water5 [weight= weight], factor(1)

predict factor_PCA


* The following line uses the command factor with its default methodo (pf)
* In this case, it produces similar results than those from pca

factor radio television refrigerator bicycle motorbike car telephone electricity floor roof crowding d_wall1 d_wall2 d_wall3 d_toilet1 d_toilet2 d_toilet3 d_cookingfuel1 d_cookingfuel2 d_cookingfuel3 d_water1 d_water2 d_water3 d_water4 d_water5 [weight= weight], factor(1) pf

predict factor_PF


* Note who similar these results are with each other

ktau	factor_PF factor_PCF factor_PCA, stats(taub)
corr    factor_PF factor_PCF factor_PCA


* Given that the variables are ordinals, the analysis might be done using polychoric correlations 
* We follow here Kolenikov, 2009 (Review de Income and Wealth)
* For a brief review: http://www.ats.ucla.edu/stat/stata/faq/efa_categorical.htm

* To install polychoric command
* findit polychoric

*polychoric radio television refrigerator bicycle motorbike car telephone water cookingfuel toilet electricity floor wall roof crowding [weight = weight]

/* Note that if you run polychoric including all variables, there will be missing values, because refrigerator, car and motorbyke are not common assets, and when mixing 
them with radio, wall or roof, there is an "inclusion" in the categories. An alternative when running polychoric would be to exclude these three conflicting variables.
Also, there is a very high correlation between television/roof and television/wall which also generates some problems. To avoide this problem we also exclude television */

polychoric radio bicycle telephone water cookingfuel toilet electricity floor wall roof crowding [weight = weight] 

display r(sum_w)
matrix r = r(R)
factormat r, n(1997) factor(1)	/* n(#), where # is the total number of observations in your sample */

predict factor_polych

xtile quant_pol	= factor_polych, nq(5)
xtile quant_pf	= factor_PF, nq(5)
xtile quant_pcf = factor_PCF, nq(5)
xtile quant_pca = factor_PCA, nq(5)

tabstat hh_no_underwa2 eduyears edulevel [weight= weight], by(quant_pol)
tabstat hh_no_underwa2 eduyears edulevel [weight= weight], by(quant_pcf)

log close
